;+
; argument tidx to tablica dwch indeksw od ktrych procedura rozpocznie
; poszukiwanie rekordw speniajcych warunek na LWC ([tidx_impact, tidx_rico])
; przykadowe uycie: > zad5_1, [45000, 20000]
;-
pro zad5_2d, tidx
  ; ustawienia i stae
  rico = 1L      & impact = 0L;
  fast_min = 2.  & fast_max = 47.   ; [um]
  cdnc_min = 10  & cdnc_max = 10000 ; [cm-3]
  lwc_min = .2   & lwc_max = .21     ; [g/kg]
  nbins = 40     & binsize = (fast_max - fast_min) / nbins

  ; alokacja pamici, otworzenie plikw z danymi
  files = objarr(2, /nozero)
  pdf_y = ptrarr(2, /nozero)
  files[impact] = obj_new('netcdf', 'IMPACT_RF50_20080514_Fast-FSSP_01Hz.nc');
  files[rico] = obj_new('netcdf', 'RICO_RF09_20041220_Fast-FSSP_10Hz.nc')

  ; ptla umieszczajca w pdf_y wskaniki do tablic z pierwszymi napotkanymi (po tidx) widmami speniajcym kryterium na LWC
  for campaign = 0, rico > impact do begin
    for Time_idx = tidx[campaign], files[campaign]->dim_getSize('Time') - 1L do begin
      lwc = (files[campaign]->var_GetSlab('FSTFSSP_LWC', Time=Time_idx))[0]
      if lwc lt lwc_max and lwc gt lwc_min then begin
        cdnc = (files[campaign]->var_GetSlab('FSTFSSP_CTOT', Time=Time_idx))[0]
        perc_5_95 = files[campaign]->var_GetSlab('FSTFSSP_CONC_PERC', Time=Time_idx)
        if n_elements(perc_5_95) gt 19 then perc_5_95 = total(total(perc_5_95[0,0,*], 1), 1)
        pdf_y[campaign] = ptr_new(perc2hist([[fast_min], perc_5_95, [fast_max]], nbins, locations=pdf_x) * cdnc / binsize)
        break ; wyjcie z ptli po pierwszym napotkanym rekordzie speniajcym kryterium
      endif
    endfor
    obj_destroy, files[campaign]
  endfor

  ; rysowanie wykresw
  !P.MULTI = [0,2,3,0,1]
  pdf_x += .5 * binsize
  xt = "rozmiar kropelki [um]"
  plot,  pdf_x,                   *(pdf_y[impact]), ps=10, th=5, chars=2, xtit=xt, ytit="n_N [um-1 cm-3]"
  oplot, pdf_x,                   *(pdf_y[rico]),   ps=10, th=10
  plot,  pdf_x, !PI   * pdf_x^2 * *(pdf_y[impact]), ps=10, th=5, chars=2, xtit=xt, ytit="n_S [um cm-3]"
  oplot, pdf_x, !PI   * pdf_x^2 * *(pdf_y[rico]),   ps=10, th=10
  plot,  pdf_x, !PI/6 * pdf_x^3 * *(pdf_y[impact]), ps=10, th=5, chars=2, xtit=xt, ytit="n_V [um2 cm-3]"
  oplot, pdf_x, !PI/6 * pdf_x^3 * *(pdf_y[rico]),   ps=10, th=10
  xt = "ln(rozmiar kropelki / 1 um) [1]"
  plot,  alog(pdf_x),         pdf_x   * *(pdf_y[impact]), ps=10, th=5, chars=2, xtit=xt, ytit="n^e_N [cm-3]"
  oplot, alog(pdf_x),         pdf_x   * *(pdf_y[rico]),   ps=10, th=10
  plot,  alog(pdf_x), !PI   * pdf_x^3 * *(pdf_y[impact]), ps=10, th=5, chars=2, xtit=xt, ytit="n^e_S [um2 cm-3]"
  oplot, alog(pdf_x), !PI   * pdf_x^3 * *(pdf_y[rico]),   ps=10, th=10
  plot,  alog(pdf_x), !PI/6 * pdf_x^4 * *(pdf_y[impact]), ps=10, th=5, chars=2, xtit=xt, ytit="n^e_V [um3 cm-3]"
  oplot, alog(pdf_x), !PI/6 * pdf_x^4 * *(pdf_y[rico]),   ps=10, th=10

end
